/* $Id: debug.h,v 1.6 2001/06/22 05:40:18 roesch Exp $ */
/*
** Copyright (C) 1998,1999,2000,2001 Martin Roesch <roesch@clark.net>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef DEBUG_H
#define DEBUG_H

#include "snort.h"


#define DEBUG_VARIABLE "SNORT_DEBUG"

#define DEBUG_ALL             0xffff
#define DEBUG_INIT            1
#define DEBUG_CONFIGRULES     2
#define DEBUG_PLUGIN          4
#define DEBUG_DATALINK        8
#define DEBUG_IP              16
#define DEBUG_TCPUDP          32
#define DEBUG_DECODE          64
#define DEBUG_LOG             128
#define DEBUG_MSTRING         256
#define DEBUG_PARSER          512
#define DEBUG_PLUGBASE        1024
#define DEBUG_RULES           2048
#define DEBUG_FLOW            4096
#define DEBUG_STREAM          8192


#ifdef DEBUG

extern char *DebugMessageFile;
extern int DebugMessageLine;

#define    DebugMessage    DebugMessageFile = __FILE__; DebugMessageLine = __LINE__; DebugMessageFunc

void DebugMessageFunc(int , char *, ...);

int GetDebugLevel (void);

#else 

static __inline__ void DebugMessage(int dbg,char *fmt, ...) {}

#endif /* DEBUG */


#endif /* DEBUG_H */
